package com.huimv.guowei.admin.utils;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.guowei.admin.entity.*;
import com.huimv.guowei.admin.entity.vo.EnvRegularCallEggVo;
import org.jxls.common.Context;
import org.jxls.util.JxlsHelper;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Print {
    /**
     * 打印方法  不插入图片
     *
     * @return
     * @throws Exception
     */
    public static void printDuck(BaseDuckInfo duckInfo, List<DuckHealthInfo> healthInfos,
                                 List<DuckImmunityInfo> immunityInfos, List<EnvMoveCall> envMoveCalls) throws Exception {
        //准备数据
        String path = "/opt/guowei/duck.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/duck.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        context.putVar("duckCode", duckInfo.getDuckNum());
        if (duckInfo.getDuckBreed() == 1) {
            context.putVar("duckType", "北京鸭");
        } else if (duckInfo.getDuckBreed() == 2) {
            context.putVar("duckType", "连城白鸭");
        } else if (duckInfo.getDuckBreed() == 3) {
            context.putVar("duckType", "山麻鸭");
        } else if (duckInfo.getDuckBreed() == 4) {
            context.putVar("duckType", "攸县麻鸭");
        } else if (duckInfo.getDuckBreed() == 5) {
            context.putVar("duckType", "白改鸭");
        } else if (duckInfo.getDuckBreed() == 6) {
            context.putVar("duckType", "缙云麻鸭");
        } else if (duckInfo.getDuckBreed() == 7) {
            context.putVar("duckType", "绍兴鸭(带圈白翼梢)");
        } else if (duckInfo.getDuckBreed() == 8) {
            context.putVar("duckType", "绍兴鸭(红毛绿翼梢)");
        } else if (duckInfo.getDuckBreed() == 9) {
            context.putVar("duckType", "绍兴鸭(白羽绍鸭)");
        }

        if (duckInfo.getDuckSex() == 0) {
            context.putVar("duckSex", "雌");
        } else {
            context.putVar("duckSex", "雄");
        }

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        context.putVar("duckDate", sdf.format(duckInfo.getDuckBirthday()));
        context.putVar("address", duckInfo.getDuckBirthplace());
        context.putVar("father", duckInfo.getFatherNum());
        context.putVar("father2", duckInfo.getFatherGenotype());
        context.putVar("mother", duckInfo.getMotherNum());
        context.putVar("mother2", duckInfo.getMotherGenotype());
        String s = "";
        String s1 = "";
        String s2 = "";
        //健康状况
        for (DuckHealthInfo healthInfo : healthInfos) {
            if ("".equals(healthInfo.getHealthResult()) || null == healthInfo.getHealthResult()) {
                s1 = sdf.format(healthInfo.getHealthDate()) + "无" + ";" + "\n" + s1;
            } else {
                s1 = sdf.format(healthInfo.getHealthDate()) + healthInfo.getHealthResult() + ";" + "\n" + s1;
            }
        }
        //日龄体重
        for (EnvMoveCall envMoveCall : envMoveCalls) {
            if ("".equals(envMoveCall.getDayage()) || null == envMoveCall.getDayage()) {
                s = "0" + "日龄 体重" + ":" + envMoveCall.getDuckWeight() + "KG;" + "\n" + s;
            } else {
                s = envMoveCall.getDayage() + "日龄 体重" + ":" + envMoveCall.getDuckWeight() + "KG;" + "\n" + s;
            }

        }
        //免疫记录
        for (DuckImmunityInfo immunityInfo : immunityInfos) {
            if (("").equals(immunityInfo.getVaccination()) || null == immunityInfo.getVaccination()) {
                s2 = sdf.format(immunityInfo.getHealthDate()) + "无" + ";" + "\n" + s2;
            } else {
                s2 = sdf.format(immunityInfo.getHealthDate()) + immunityInfo.getVaccination() + ";" + "\n" + s2;
            }

        }
        context.putVar("weight", s);
        context.putVar("need", duckInfo.getSpecialNeeds());
        context.putVar("env", duckInfo.getBreedingEnv());
        context.putVar("record", s1);
        context.putVar("record2", s2);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

    public static void printEgg(List<EnvRegularCallEggVo> eggs) throws Exception {

        //准备数据
        String path = "/opt/guowei/egg.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/egg.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<EnvRegularCallEggVo> list = new ArrayList<>();
        for (EnvRegularCallEggVo egg : eggs) {
            EnvRegularCallEggVo eggVo = new EnvRegularCallEggVo();
            eggVo.setEggNum(egg.getEggNum());
            eggVo.setDuckCode(egg.getDuckCode());
            eggVo.setDate(egg.getDate());
            eggVo.setFeed(egg.getFeed());
            eggVo.setWeight(egg.getWeight());
            list.add(eggVo);
        }
        context.putVar("list", list);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

}